#include <stdio.h>      /*   /  */
#include <signal.h>     /*                   */
#include <ctype.h>      /*         */
#include <dirent.h>     /*    BSD 4.2 */
#include <pwd.h>        /*   /etc/passwd              */
#include <termios.h>
#include <fcntl.h>
#include <pthread.h>    /*                    */
#include <time.h>       /*             */

#include <sys/types.h>
#include <sys/wait.h>

#include "cmdline.h"
#include "tok.h"
#include "exec.h"
#include "io.h"

static int  clock_off_on = 1; // 1/0 / 

void clock_step(void)
{
 time_t c; //  

 if( clock_off_on )
 {
  register char* h,*m,*s; // , , 
  time(&c);
  // ctime  'Sat Nov  2 15:14:02 2002'
  h = ctime(&c) + 11; h[2] = '\0';
  m = h + 3; m[2] = '\0';
  s = m + 3; s[2] = '\0';
  
//   
// save curpos        \e7
// gotoXY(73,1)       \e[1;73H
// .      \e[m
//    \e[2m
// write(h,':',m,':',s)    
// .      \e[m 
// load curpos        \e8
  fprintf(stderr,"\e7\e[1;73H\e[m\e[2m%s:%s:%s\e8",h,m,s);
  
 }  
}

void* __clock(void* x)// 
{
 for(;;)
 {
  clock_step();
  sleep(1); //  1- .
 } 
 return 0;
}


void sigCHILD(int s){  waitpid(-1,NULL,WNOHANG);}


void setcwd() /*     */
{
 char cwd[512]; getcwd(cwd,512); setenv( "CWD", cwd );
}

main()
{
 char *user = "root";      /*       */
 char *home = "/root";     /*    */
 int uid = getuid(); //  uid
 struct passwd *p = getpwuid(uid); // -    uid
 register i; // ޣ   
 int chpid; /*  ģ  */
 
 if( p != NULL )
 {
    if(p->pw_name && *p->pw_name ) user = p->pw_name;
    if(               *p->pw_dir ) home = p->pw_dir;
 }
 setenv("USER", user); setenv("HOME", home);
 setenv("home", home); setenv("path", ".:/bin:/sbin:/usr/bin:/usr/sbin");
 setenv("status","0");
 
 
 
  //   .
   {
    sigset_t cldset; // 
    
        sigemptyset(&cldset); //  SIGTTOU
        sigaddset(&cldset,SIGTTOU); // 
        sigprocmask(SIG_BLOCK,&cldset,0); //
			
        signal(SIGINT,SIG_IGN);
        signal(SIGCHLD,sigCHILD);
    }
			 
 
 //      Σ  clock
 {
  pthread_t thread; //  
  
  if( pthread_create(&thread,NULL,__clock,NULL) )
  fprintf(stderr,"sash-->    .\n");
 } 
 
 for(i=0; i<MAXARGS; i++) args[i]=NULL;
 
 for(;;)
 {/*       */ 
#define ioopen if( outp )\
    if((fp = fopen(outp, outflg & APPEND ? "a":"w")) == NULL)\
    {\
     fprintf(stderr,"yash:     %s\n",outp);\
     continue;\
    }
   
#define ioclose if( fp != stdout ) fclose(fp);

  FILE* fp = stdout; //       
  
  char *s; //    

  s = getcmd(); //   
  

  clock_step(); //       ,   
		 //    
  
  tok(s); // ߣ   
  
  if(argn==0) continue;

  if(strcmp(args[0],"clock")==0)
  {
#define ERRCLOCK { fprintf(stderr,"sash-->  clock on|off\n"); continue;}  
   if(argn!=2) ERRCLOCK;
   if(strcmp(args[1],"on")==0) 
   {
    clock_off_on = 1;
   }
   else if(strcmp(args[1],"off")==0) 
   {
    clock_off_on = 0;
    fprintf(stderr,"\e7\e[1;73H        \e8");
   }
   else ERRCLOCK;
#undef ERRCLOCK   
   continue;
  }
  
  if(strcmp(args[0],"logout")==0) exit(0);
  if(strcmp(args[0],"exit")==0) puts("sash-->  sash ۣ"), exit(0);
  if(strcmp(args[0],"date")==0)
  {
   time_t try; 
   ioopen; // io
   time(&try); fprintf(fp,"%s",ctime(&try)); 
   ioclose; // io
   continue;
  }
  if(strcmp(args[0],"pwd")==0)
  {
#define CS 516   
   char gdir[CS];
   ioopen; // io
    fprintf(fp,"%s\n",getcwd(gdir,CS)); 
   ioclose; // io
#undef CS   
   continue;
  }
  if(strcmp(args[0], "cd" )==0)
  {
   char *d = (argn==1) ? (char*)getenv("HOME"):args[1];
   if(chdir(d) < 0) fprintf(stderr,"    `%s`\n", d ); else setcwd();
   continue;
  }
  if(strcmp(args[0], "cd.." )==0) { chdir(".."); setcwd(); continue;}
  if(strcmp(args[0], "echo" )==0) 
  {
   ioopen;  // io
   for(i=1; i<argn; i++)  fprintf(fp,"%s%c",args[i],argn==i+1 ? '\n':' ');
   ioclose; // io
   continue;
  } 
  if(strcmp(args[0], "sdir" )==0) 
  {
   struct dirent *ep;
   char* dname = argn>1 ? args[1]:"./";
   DIR* dp = opendir(dname);
   ioopen;   // io
   if(dp!=0)
   {
    while(ep = readdir(dp)) //    ep->d_ino;
     if(strcmp(ep->d_name,"..") && strcmp(ep->d_name,".")) 
     fprintf(fp,"%s\t",ep->d_name);
    closedir(dp);     
     fprintf(fp,"\n");
   }  else fprintf(stderr," `%s`  .\n",dname);
   ioclose; // io
   continue;
  }

  if(strcmp(args[0], "set" )==0)   
  {
   if( argn != 4 ) fprintf(stderr,"sash-->  set A = B\n");
   else  
   {
    if( strcmp(args[2],"=")!=0 ) fprintf(stderr,"sash-->  set A = B\n");
    else setvar( args[1], args[3] ); //   
   }
   continue;
  }
  if(strcmp(args[0], "unset" )==0) 
  {
   if(args[1]) unsetvar(args[1]);
   continue;
  }  
  if(strcmp(args[0],"getenv")==0) //  
  {
   for(i=0; environ[i]; i++) 
   { register j=19;
     if(i==j) printf("\t\t\t\t  *****"), getchar(), j+=19;
     printf("%s\n",environ[i]);
   }
   continue; 
  }
  if(strcmp(args[0],"setenv")==0)
  { /*    */
   if(argn>1) setenv(args[1],(char*)strdup(findvar(args[1])));
   continue;
  }
  
   cmdExec(args[0],args,environ); //   
 }
}
